package  
{
	import flash.geom.ColorTransform;
	import flash.geom.Point;
	import flash.sampler.NewObjectSample;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.Sfx;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.FP;
	
	/**
	 * ...
	 * @author tony
	 */
	public class PlayerBall extends Entity 
	{
		public var bumper:Sfx = new Sfx(Assets.snd_bump);
		public var following:Boolean = false;
		
		public var vel: Point = new Point(0, 0);
		public var scut_to_follow:Scut;
		//public var x_vel: Number = 0;
		//public var y_vel: Number = 0;
		
		public function PlayerBall() 
		{
			type = "player_ball";
			graphic = new Image(Assets.img_player_ball);
			(graphic as Image).centerOO();
			
			
			x = FP.bounds.right / 2 + 100;
			y = FP.bounds.bottom / 2;
		}
		
		
		override public function update():void
		{
			//(graphic as Image).angle = FP.rand(360);
			(graphic as Image).scaleX = 1.5 - (FP.random / 4);
			(graphic as Image).scaleY = 1.5 - (FP.random / 4);
			vel.x *= .99;
			vel.y *= .99;
			x += vel.x;
			y += vel.y;
			
			var e_list:Array = [];
			world.getType("player", e_list);
			var playa:Player = (e_list[0] as Player);
			
			
			if (!following)
			{
				
				if (scut_to_follow == null)
				{
					dart_list = [];
					world.getType("scut", dart_list);
					for each (var scut:Scut in dart_list)
					{
						if (distanceFrom(scut) < 20)
						{
							ang = FP.angle(x, y, scut.x, scut.y);
							var v: Point = vel;
							v.normalize(1);
							scut.x_vel = v.x;
							scut.y_vel = v.y;
							new Sfx(Assets.snd_scutt_catch).play();
							//bumper.play();
							//scut.x_vel = Math.cos(ang * 0.01745) * 1;
							//scut.y_vel = Math.sin(ang * 0.01745) * -1;
							//scut.moveTowards(x, y, -3);
							//var pp: Point = vel;
							//pp.normalize(1);
							//pp.y *= -1;
							//scut.x_vel = pp.x;
							//scut.y_vel = pp.y;
							
							
							
				//_point.x = x - this.x;
				//_point.y = y - this.y;
				//_point.normalize(amount);
							
							//x = playa.x;
							//y = playa.y;
							//var len:Number = vel.length;
							//
							//ang = FP.angle(x, y, scut.x, scut.y);
							//vel.x = Math.cos(ang * 0.01745) * len;
							//vel.y = Math.sin(ang * 0.01745) * len;
							vel.x = 0;
							vel.y = 0;
							
							scut_to_follow = scut;
							
							//moveTowards(scut.x, scut.y, -10);
						}
					}
					
				}
			}
			
			if (scut_to_follow != null)
			{
				x = scut_to_follow.x;
				y = scut_to_follow.y;
			}
			
			if (following)
			{
				if (scut_to_follow == null)
				{
					//if (distanceFrom(playa) > 10)
					//{
					x = playa.x - .5;
					y = playa.y;
						//vel.x = playa.x - this.x;
						//vel.y = playa.y - this.y;
						//vel.normalize(5);
						//x += vel.x * .01;
						//y += vel.y * .01;
						//moveTowards(playa.x, playa.y, 10);
					//}
					
					
					if (Input.mousePressed)
					{
						following = false;
						
						new Sfx(Assets.snd_throw_the_ball).play();
						
						vel.x = Input.mouseX - this.x;
						vel.y = Input.mouseY - this.y;
						vel.normalize(5);
						x += vel.x * 4;
						y += vel.y * 4;
					}
					
				}
			}
			else
			{
				if (distanceFrom(playa) < 20)
				{
					new Sfx(Assets.snd_pickup_ball).play();
					following = true;
					scut_to_follow = null;
					vel.x = 0;
					vel.y = 0;
				}
			}
			
			
			//var dart_list:Array = [];
			//world.getType("dart", dart_list);
			//
			//for each (var td:TempleDart in dart_list)
			//{
				//if (distanceFrom(td) < 25)
					//td.moveTowards(x, y, -3);
			//}
			
			var dart_list:Array = [];
			world.getType("dart", dart_list);
			
			for each (var td:TempleDart in dart_list)
			{
				if (this.distanceFrom(td) < 25)
				{
					//if (!bumper.playing)
						bumper.play();
					var ang:Number = FP.angle(x, y, td.x, td.y);
					td.vel.x += Math.cos(ang * 0.01745) * .5;
					td.vel.y -= Math.sin(ang * 0.01745) * .5;
					//td.moveTowards(x, y, -3);
				}
			}
			
			dart_list = [];
			world.getType("proxy", dart_list);
			for each (var prox:Proxy in dart_list)
			{
				if (distanceFrom(prox) < 25)
				{
					ang = FP.angle(x, y, prox.x, prox.y);
					prox.x_vel += Math.cos(ang * 0.01745) * 5;
					prox.y_vel -= Math.sin(ang * 0.01745) * 5;
					
					//if (!bumper.playing)
						bumper.play();
					//prox.moveTowards(x, y, -3);
				}
			}
			
			
			
			
			if (x < 0)
			{
				x = 5;
				vel.x *= -1;
			}
			if (x > FP.bounds.right)
			{
				x = FP.bounds.right - 5;
				vel.x *= -1;
			}
			if (y < 0)
			{
				y = 5;
				vel.y *= -1;
			}
			if (y > FP.bounds.bottom)
			{
				y = FP.bounds.bottom - 5;
				vel.y *= -1;
			}
		}
		
	}

}