package  
{
	import flash.geom.ColorTransform;
	import flash.geom.Point;
	import flash.sampler.NewObjectSample;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.Sfx;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.FP;
	
	/**
	 * ...
	 * @author tony
	 */
	public class RedHole extends Entity 
	{
		public var timer:int = 0;
		public var corner:int = 0;
		public function RedHole() 
		{
			type = "red_hole";
			graphic = new Image(Assets.img_red_hole);
			(graphic as Image).centerOO();
		}
		
		override public function update():void 
		{
			(graphic as Image).angle = FP.rand(360);
			(graphic as Image).scaleX = 1.5 - (FP.random / 8);
			//(graphic as Image).scaleY = 1.5 - FP.random;
			
			
			
			super.update();
			
			var dart_list:Array = [];
			dart_list = [];
			world.getType("proxy", dart_list);
			for each (var prox:Proxy in dart_list)
			{
				if (distanceFrom(prox) < 35)
				{
					FP.world.remove(prox);
					new Sfx(Assets.snd_enemy_death).play();
				}
			}
			
			
			dart_list = [];
			world.getType("scut", dart_list);
			for each (var scut:Scut in dart_list)
			{
				if (distanceFrom(scut) < 35)
				{
					FP.world.remove(scut);
					new Sfx(Assets.snd_enemy_death).play();
					var e_list:Array = [];
					world.getType("player_ball", e_list);
					var ball:PlayerBall = (e_list[0] as PlayerBall);
					if (scut == ball.scut_to_follow)
						ball.scut_to_follow = null;
				}
			}
			
			
			
			timer++;
			if (timer > 60 * 3)
			{
				new Sfx(Assets.snd_red_hole_move).play();
				timer = 0;
				corner++;
				if (corner > 3) corner = 0;
				switch(corner)
				{
					case 0:
						x = 100;
						y = 100;
						break;
					case 1:
						x = FP.bounds.right - 100;
						y = 100;
						break;
					case 2:
						x = FP.bounds.right - 100;
						y = FP.bounds.bottom - 100;
						break;
					case 3:
						x = 100;
						y = FP.bounds.bottom - 100;
						break;
				}
			}
			
		}
		
	}

}