package
{
	import flash.events.TextEvent;
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.Sfx;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.World;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.FP;
	
	public class world_game extends World
	{
		public var end_wave_timer:int = 0;
		public var end_wave_timer_begun:Boolean = true;
		//public var wave_started = false;
		public var wave: int = 0;
		//public var player : Player = new Player();
		
		public var wave_text: String = "puke";
		
		
		public var lastscore: int = 0;
		public var highscore : int = 0;
		
		public function world_game(ls:int, hs:int)
		{
			
			lastscore = ls;
			highscore = hs;
			
			addGraphic(new Image(Assets.img_game_bg));
			var tmpl_A:Image = new Image(Assets.img_templ_area);
			tmpl_A.centerOO();
			
			addGraphic(tmpl_A, 0, FP.bounds.right / 2, FP.bounds.bottom / 2);
			
			var d:Number = 18;
			add(new TempleDart(FP.bounds.right / 2, (FP.bounds.bottom / 2) - d - 5, false));
			add(new TempleDart(FP.bounds.right / 2, (FP.bounds.bottom / 2), true));
			add(new TempleDart(FP.bounds.right / 2 - d, (FP.bounds.bottom / 2), false));
			add(new TempleDart(FP.bounds.right / 2 + d, (FP.bounds.bottom / 2), false));
			add(new TempleDart(FP.bounds.right / 2 - d, (FP.bounds.bottom / 2) + d + 5, true));
			add(new TempleDart(FP.bounds.right / 2 + d, (FP.bounds.bottom / 2) + d + 5, true));
			
			add(new TempleDart(FP.bounds.right / 2 - d - d, (FP.bounds.bottom / 2) + d + 5, false));
			add(new TempleDart(FP.bounds.right / 2, (FP.bounds.bottom / 2) + d + 5, false));
			add(new TempleDart(FP.bounds.right / 2 + d + d, (FP.bounds.bottom / 2) + d + 5, false));
			
			add(new PlayerBall());
			add(new Player());
			//add(new Proxy());
			
			var rh:RedHole = new RedHole();
			rh.x = 100;
			rh.y = 100;
			add(rh);
		}
		
		override public function update():void
		{
			super.update();
			
			if (Input.check(Key.X))
			{
				add(new Proxy());
			}
			
			if (Input.check(Key.C))
			{
				add(new Scut());
			}
			
			var wait_time:int = 60 * 8;
			
			var ents:Array = [];
			
			getType("dart", ents);
			if (ents.length < 1)
			{
				//kill the player
				new Sfx(Assets.snd_death).play();
				if (wave > highscore) highscore = wave;
				FP.world = new world_menu(wave, highscore);
			}
			
			
			
			
			ents = [];
			getType("proxy", ents);
			getType("scut", ents);
			if (ents.length < 1)
			{
				//wave_started = false;
				if (!end_wave_timer_begun)
					new Sfx(Assets.snd_cheer).play();
				end_wave_timer_begun = true;
				end_wave_timer++;
				wave_text = "time till next wave: " + ((wait_time) - end_wave_timer).toString();
			}
			
			if (end_wave_timer_begun)
			{
			}
			
			
			if (end_wave_timer > wait_time && end_wave_timer_begun)
			{
				new Sfx(Assets.snd_wave_start).play();
				end_wave_timer = 0;
				end_wave_timer_begun = false;
				//wave_started = true;
				wave++;
				//for (var i:int = 0; i < wave; i++)
				//{
					switch(wave)
					{
						case 1:
							add(new Proxy());
							wave_text = "Hello Wlecome to your doom.";
							break;
						case 2:
							add(new Proxy());
							wave_text = "I call those purple guys Proxies.";
							break;
						case 3:
							add(new Proxy());
							add(new Proxy());
							wave_text = "They are going to kill you.";
							break;
						case 4:
							add(new Proxy());
							add(new Proxy());
							add(new Proxy());
							wave_text = "Without your temple, you will die.";
							break;
						case 5:
							add(new Scut());
							wave_text = "Scutts have yellow eyes.";
							break;
						case 6:
							add(new Proxy());
							add(new Proxy());
							wave_text = "I don't like you on my planet!";
							break;
						case 7:
							add(new Proxy());
							add(new Proxy());
							add(new Scut());
							wave_text = "I'm throwing all my minions at you";
							break;
						case 8:
							add(new Proxy());
							add(new Proxy());
							add(new Proxy());
							add(new Scut());
							add(new Scut());
							wave_text  = "Now it's party time..";
							break;
						case 9:
							add(new Proxy());
							add(new Proxy());
							add(new Proxy());
							add(new Proxy());
							add(new Proxy());
							wave_text = "Try this on for size!!!";
							break;
						case 10:
							add(new Scut());
							add(new Scut());
							add(new Scut());
							add(new Scut());
							add(new Scut());
							add(new Proxy());
							wave_text = "DIE!!!";
							break;
						default:
							wave_text = "";
							for (var i:int = 0; i < wave; i++)
								add(FP.choose(new Scut(), new Proxy()));
							break;
					//}
				}
			}
			
			//var dart_list:Array = [];
			//getType("dart", dart_list);
			//
			//for each (var td:TempleDart in dart_list)
			//{
			//if (td.distanceFrom(td) < 18)
			//td.moveTowards(x, y, -1);
			//}
			
			var dart_list:Array = [];
			getType("dart", dart_list);
			
			for each (var td:TempleDart in dart_list)
			{
				for each (var td_2:TempleDart in dart_list)
				{
					if (td != td_2)
						if (td_2.distanceFrom(td) < 18)
						{
							var ang:Number = FP.angle(td_2.x, td_2.y, td.x, td.y);
							td.vel.x += Math.cos(ang * 0.01745) * .1;
							td.vel.y -= Math.sin(ang * 0.01745) * .1;
							
							//ang = FP.angle(td.x, td.y, td_2.x, td_2.y);
							td_2.vel.x += Math.cos(-ang * 0.01745) * .1;
							td_2.vel.y -= Math.sin(-ang * 0.01745) * .1;
								//td.vel.x += 2;
								//td.vel.add(d);
								//td.moveTowards(td_2.x, td_2.y, -1);
								//var a: Number = FP.angle(td.x, td.y, td_2.x, td_2.y);
								//FP.
						}
				}
			}
		
		}
		
		override public function render():void
		{
			super.render();
			
			Text.size = 32;
			Draw.graphic(new Text("WAVE: " + wave.toString() + " / 10"), 144, 0);
			Text.size = 18;
			
			var dis: Text = new Text(wave_text, 20, 50);
			dis.color = FP.getColorRGB(FP.rand(254), FP.rand(254), FP.rand(254));
			Draw.graphic(dis);
			
			
		}
	}

}