package  
{
	import flash.geom.ColorTransform;
	import flash.geom.Point;
	import flash.sampler.NewObjectSample;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.Sfx;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.FP;
	
	/**
	 * ...
	 * @author tony
	 */
	public class TempleDart extends Entity 
	{
		public var vel:Point = new Point(0, 0);
		
		public var image: Image = new Image(Assets.img_templ_dart);
		public var tint:Image = new Image(Assets.img_templ_dart);
		
		public function TempleDart(_x:Number, _y:Number, flip:Boolean) 
		{
			type = "dart";
			x = _x;
			y = _y;
			//image.angle = _ang;
			
			setHitbox(20, 20);
			
			if (flip)
			{
				image.scaleY = -1;
				tint.scaleY = -1;
			}
			//image.centerOrigin();
			//image.x = -16;
			//image.y = -16;
			image.centerOO();
			graphic = image;
			//tint.color = 0xff0000;
			//tint.alpha = 0;
			tint.centerOO();
			//graphic = tint;
			//(graphic as Image).color = 0xff0000;
		}
		
		override public function update():void
		{
			x += vel.x;
			y += vel.y;
			
			vel.x *= .9;
			vel.y *= .9;
			
			if (distanceToPoint(FP.bounds.right / 2, FP.bounds.bottom / 2) > 124)
			{
				FP.world.remove(this);
				new Sfx(Assets.snd_lost_dart).play();
				//tint.alpha += .04;
				//if (tint.alpha > 1) tint.alpha = 1;
			}
			//else
			//{
				//tint.alpha -= .04;
				//if (tint.alpha < 0) tint.alpha = 0;
			//}
		}
		
		//override public function render():void
		//{
			//Draw.graphic(image, x, y);
			//Draw.graphic(tint, x, y);
		//}
		
		
	}

}